#pragma once


// STD/STL
#include <vector>

// ArmarX
#include <ArmarXCore/core/Component.h>

// RobotAPI
#include <RobotAPI/libraries/aron/aroncore/navigators/datanavigator/AronAllDataNavigators.h>
#include <RobotAPI/interface/armem/mns/MemoryNameSystemInterface.h>
#include <RobotAPI/interface/armem/server/ReadingMemoryInterface.h>
#include <RobotAPI/interface/armem/client/MemoryListenerInterface.h>

#include <RobotAPI/libraries/armem/client/Reader.h>
#include <RobotAPI/libraries/armem/mns/ClientPlugin.h>


namespace armarx::armem::client::plugins
{

    class ReaderComponentPlugin :
        public mns::plugins::ClientPlugin
    {

    public:

        using mns::plugins::ClientPlugin::ClientPlugin;
        ~ReaderComponentPlugin() override;

        void postCreatePropertyDefinitions(PropertyDefinitionsPtr& properties) override;

    };

}


namespace armarx::armem::client
{

    class ReaderComponentPluginUser :
        virtual public ManagedIceObject,
        virtual public mns::plugins::ClientPluginUserBase,
        virtual public MemoryListenerInterface
    {

    public:

        ReaderComponentPluginUser();
        ~ReaderComponentPluginUser() override;


        virtual void memoryUpdated(const std::vector<data::MemoryID>& updatedSnapshotIDs, const Ice::Current& current) override;


    protected:

        void setReadingMemory(server::ReadingMemoryInterfacePrx memory);

        virtual armem::data::WaitForMemoryResult useMemory(const std::string& memoryName) override;
        using mns::plugins::ClientPluginUserBase::useMemory;


    protected:

        Reader memoryReader;


    private:

        plugins::ReaderComponentPlugin* plugin = nullptr;

    };

}
