#include "NlohmannJSONDiskReader.h"

#include <RobotAPI/libraries/aron/aroncore/io/AronDataIO/AronDataConverter/AronDataConverter.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronDataIO/classReaders/NlohmannJSONReader/AronDataNlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronDataIO/classWriters/NavigatorWriter/AronDataNavigatorWriter.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronTypeIO/AronTypeConverter/AronTypeConverter.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronTypeIO/classReaders/NlohmannJSONReader/AronTypeNlohmannJSONReader.h>


namespace armarx::armem::io
{

    NlohmannJSONDiskReader::NlohmannJSONDiskReader(bool createFolder) :
        DiskReaderWriter(createFolder),
        DiskReader(createFolder)
    {
    }

    NlohmannJSONDiskReader::NlohmannJSONDiskReader(const std::string& rootPath, bool createFolder) :
        DiskReaderWriter(rootPath, createFolder),
        DiskReader(rootPath, createFolder)
    {
    }

    aron::datanavigator::AronDictDataNavigatorPtr NlohmannJSONDiskReader::getStringAsDataNavigator(const std::string& s, const aron::typenavigator::AronTypeNavigatorPtr& expectedStructure) const
    {
        aron::io::AronDataNlohmannJSONReader dataReader(s);
        aron::io::AronDataNavigatorWriter navWriter;
        aron::io::AronDataConverter::ConvertFromReader(dataReader, navWriter, expectedStructure);
        return aron::datanavigator::AronDictDataNavigator::DynamicCastAndCheck(navWriter.getResult());
    }

    aron::typenavigator::AronObjectTypeNavigatorPtr NlohmannJSONDiskReader::getStringAsTypeNavigator(const std::string& s) const
    {
        aron::io::AronTypeNlohmannJSONReader typeReader(s);
        aron::io::AronTypeNavigatorWriter navWriter;
        aron::io::AronTypeConverter::ConvertFromReader(typeReader, navWriter);
        return aron::typenavigator::AronObjectTypeNavigator::DynamicCastAndCheck(navWriter.getResult());
    }
}
