#include "NlohmannJSONDiskWriter.h"

#include <RobotAPI/libraries/aron/aroncore/io/AronDataIO/AronDataWriterVisitor/AronDataWriterVisitor.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronTypeIO/AronTypeWriterVisitor/AronTypeWriterVisitor.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronDataIO/classWriters/NlohmannJSONWriter/AronDataNlohmannJSONWriter.h>
#include <RobotAPI/libraries/aron/aroncore/io/AronTypeIO/classWriters/NlohmannJSONWriter/AronTypeNlohmannJSONWriter.h>


namespace armarx::armem::io
{
    NlohmannJSONDiskWriter::NlohmannJSONDiskWriter(bool createFolder) :
        DiskReaderWriter(createFolder),
        DiskWriter(createFolder)
    {
    }

    NlohmannJSONDiskWriter::NlohmannJSONDiskWriter(const std::string& rootPath, bool createFolder) :
        DiskReaderWriter(rootPath, createFolder),
        DiskWriter(rootPath, createFolder)
    {
    }

    std::string NlohmannJSONDiskWriter::getDataAsString(const aron::datanavigator::AronDictDataNavigatorPtr& aronDataNav) const
    {
        aron::io::AronDataNlohmannJSONWriter dataWriter;
        aron::io::AronDataWriterVisitor::SetupWriterFromAronDataPtr(dataWriter, aronDataNav->getResult());
        return dataWriter.getResult().dump(2);
    }

    std::string NlohmannJSONDiskWriter::getTypeAsString(const aron::typenavigator::AronObjectTypeNavigatorPtr& aronTypeNav) const
    {
        aron::io::AronTypeNlohmannJSONWriter typeWriter;
        aron::io::AronTypeWriterVisitor::SetupWriterFromAronTypePtr(typeWriter, aronTypeNav->getResult());
        return typeWriter.getResult().dump(2);
    }
}
