#include "ComponentPlugin.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>
#include <ArmarXCore/core/time/CycleUtil.h>

#include "../error.h"


namespace armarx::armem::mns::plugins
{

}


namespace armarx::armem::mns
{

    ComponentPluginUser::ComponentPluginUser()
    {
        addPlugin(plugin);
    }


    armem::data::RegisterMemoryResult ComponentPluginUser::registerMemory(const armem::data::RegisterMemoryInput& input, const Ice::Current&)
    {
        std::scoped_lock lock(mnsMutex);
        armem::data::RegisterMemoryResult result = mns.registerMemory(input);
        return result;
    }


    armem::data::RemoveMemoryResult ComponentPluginUser::removeMemory(const armem::data::RemoveMemoryInput& input, const Ice::Current&)
    {
        std::scoped_lock lock(mnsMutex);
        armem::data::RemoveMemoryResult result = mns.removeMemory(input);
        return result;
    }


    armem::data::ResolveMemoryNameResult ComponentPluginUser::resolveMemoryName(const armem::data::ResolveMemoryNameInput& input, const Ice::Current&)
    {
        std::scoped_lock lock(mnsMutex);
        armem::data::ResolveMemoryNameResult result = mns.resolveMemoryName(input);
        return result;
    }


    armem::data::WaitForMemoryResult ComponentPluginUser::waitForMemory(const armem::data::WaitForMemoryInput& input, const Ice::Current&)
    {
        // No lock - this call blocks internally.
        return mns.waitForMemory(input);
    }

}
