#pragma once

#include <mutex>

#include <ArmarXCore/core/Component.h>

#include <RobotAPI/interface/armem/server/MemoryInterface.h>
#include <RobotAPI/interface/armem/mns/MemoryNameSystemInterface.h>

#include "MemoryNameSystem.h"


namespace armarx::armem::mns::plugins
{

    class ComponentPlugin : public armarx::ComponentPlugin
    {
    public:
        using armarx::ComponentPlugin::ComponentPlugin;
    };

}


namespace armarx::armem::mns
{

    /**
     * @brief Utility for connecting a Memory to Ice.
     */
    class ComponentPluginUser :
        virtual public ManagedIceObject
        , virtual public mns::MemoryNameSystemInterface
    {
    public:

        ComponentPluginUser();

        // mns::MemoryNameSystemInterface interface
    public:
        armem::data::RegisterMemoryResult registerMemory(const armem::data::RegisterMemoryInput& input, const Ice::Current& = Ice::emptyCurrent) override;
        armem::data::RemoveMemoryResult removeMemory(const armem::data::RemoveMemoryInput& input, const Ice::Current& = Ice::emptyCurrent) override;
        armem::data::ResolveMemoryNameResult resolveMemoryName(const armem::data::ResolveMemoryNameInput& input, const Ice::Current& = Ice::emptyCurrent) override;
        armem::data::WaitForMemoryResult waitForMemory(const armem::data::WaitForMemoryInput& input, const Ice::Current& = Ice::emptyCurrent) override;


    public:

        std::mutex mnsMutex;
        MemoryNameSystem mns;


    private:

        plugins::ComponentPlugin* plugin = nullptr;


    };


}
