#pragma once

#include <RobotAPI/interface/armem/server/MemoryInterface.h>
#include <RobotAPI/interface/armem/client/MemoryListenerInterface.h>

#include "../core/Memory.h"


namespace armarx::armem::server
{


    /**
     * @brief Helps connecting a Memory server to the Ice interface.
     *
     * This involves conversion of ice types to C++ types as well as
     * catchin exceptions and converting them to error messages
     */
    class MemoryToIceAdapter
    {
    public:

        /// Construct an MemoryToIceAdapter from an existing Memory.
        MemoryToIceAdapter(Memory* memory = nullptr);

        void setMemoryListener(client::MemoryListenerInterfacePrx memoryListener);


        // WRITING

        data::AddSegmentResult addSegment(
            const data::AddSegmentInput& input, bool addCoreSegments = false);

        data::AddSegmentsResult addSegments(
            const data::AddSegmentsInput& input, bool addCoreSegments = false);


        data::CommitResult commit(const data::Commit& commitIce, Time timeArrived);
        data::CommitResult commit(const data::Commit& commitIce);
        armem::CommitResult commit(const armem::Commit& commit);


        // READING

        query::data::Result query(const armem::query::data::Input& input);


    public:

        Memory* memory;

        client::MemoryListenerInterfacePrx memoryListener;

    };


}
