#pragma once

#include <RobotAPI/interface/armem/query.h>

#include <RobotAPI/libraries/armem/core/Memory.h>

#include "BaseQueryProcessor.h"
#include "CoreSegmentQueryProcessor.h"



namespace armarx::armem::query_proc
{

    /**
     * @brief Handles memory queries.
     */
    class MemoryQueryProcessor : public BaseQueryProcessor<Memory, armem::query::data::MemoryQuery>
    {
    public:

        MemoryQueryProcessor(DataMode dataMode = DataMode::WithData) :
            BaseQueryProcessor(dataMode), coreSegmentProcessor(dataMode)
        {}


        using BaseQueryProcessor::process;

        armem::query::data::Result process(const armem::query::data::Input& input, const Memory& memory) const;


        void process(Memory& result, const armem::query::data::MemoryQuery& query, const Memory& memory) const;

        void process(Memory& result, const armem::query::data::memory::All& query, const Memory& memory) const;
        void process(Memory& result, const armem::query::data::memory::Single& query, const Memory& memory) const;
        void process(Memory& result, const armem::query::data::memory::Regex& query, const Memory& memory) const;


        data::MemoryPtr processToIce(const armem::query::data::MemoryQuery& query, const Memory& memory) const;
        data::MemoryPtr processToIce(const armem::query::data::MemoryQuerySeq& query, const Memory& memory) const;


    private:

        CoreSegmentQueryProcessor coreSegmentProcessor;

    };

}
