#pragma once

#include <RobotAPI/interface/armem/query.h>

#include <RobotAPI/libraries/armem/core/Memory.h>

#include "BaseQueryProcessor.h"
#include "EntityQueryProcessor.h"



namespace armarx::armem::query_proc
{

    /**
     * @brief Handles memory queries.
     */
    class ProviderSegmentQueryProcessor : public BaseQueryProcessor<ProviderSegment, armem::query::data::ProviderSegmentQuery>
    {
    public:

        ProviderSegmentQueryProcessor(DataMode dataMode = DataMode::WithData) :
            BaseQueryProcessor(dataMode), entityProcessor(dataMode)
        {}


        using BaseQueryProcessor::process;

        void process(ProviderSegment& result, const armem::query::data::ProviderSegmentQuery& query, const ProviderSegment& providerSegment) const;

        void process(ProviderSegment& result, const armem::query::data::provider::All& query, const ProviderSegment& providerSegment) const;
        void process(ProviderSegment& result, const armem::query::data::provider::Single& query, const ProviderSegment& providerSegment) const;
        void process(ProviderSegment& result, const armem::query::data::provider::Regex& query, const ProviderSegment& providerSegment) const;


        data::ProviderSegment processToIce(const armem::query::data::ProviderSegmentQuery& query, const ProviderSegment& providerSegment) const;


    private:

        EntityQueryProcessor entityProcessor;

    };

}
