#include "gui_utils.h"

#include <QLayout>
#include <QLayoutItem>
#include <QWidget>
#include <QTreeWidgetItem>


namespace armarx
{

    void gui::clearLayout(QLayout* layout)
    {
        // Source: https://stackoverflow.com/a/4857631

        QLayoutItem* item;
        while ((item = layout->takeAt(0)))
        {
            if (item->layout())
            {
                clearLayout(item->layout());
                delete item->layout();
            }
            if (item->widget())
            {
                delete item->widget();
            }
            delete item;
        }
    }

    void gui::clearItem(QTreeWidgetItem* item)
    {
        while (item->childCount() > 0)
        {
            delete item->takeChild(0);
        }
    }
}

