#pragma once


class QLayout;
class QTreeWidgetItem;


namespace armarx::gui
{
    /**
     * @brief Clear a layout.
     *
     * Recursively take and delete all items in `layout`.
     *
     * @param layout The layout.
     */
    void clearLayout(QLayout* layout);

    /**
     * @brief Clear a tree widget item
     *
     * Take and delete all children of `item`.
     *
     * @param item The tree widget item.
     */
    void clearItem(QTreeWidgetItem* item);

}
