#pragma once

#include <sstream>
#include <stack>

#include <QTreeWidget>
#include <QLabel>

#include <RobotAPI/libraries/aron/aroncore/navigators/visitors/DataVisitor.h>

#include "InstanceTreeDataVisitorBase.h"


namespace armarx::armem::gui
{

    class InstanceTreeDataVisitor :
        public aron::visitor::DataVisitor,
        public InstanceTreeDataVisitorBase
    {
    public:

        using InstanceTreeDataVisitorBase::InstanceTreeDataVisitorBase;


        bool visitEnter(const std::string& key, DictDataNavigator& n) override
        {
            return _visitEnter(key, "Dict", n.childrenSize());
        }
        bool visitExit(DictDataNavigator&) override
        {
            return _visitExit();
        }

        bool visitEnter(const std::string& key, ListDataNavigator& n) override
        {
            return _visitEnter(key, "List", n.childrenSize());
        }
        bool visitExit(ListDataNavigator&) override
        {
            return _visitExit();
        }


        bool visit(const std::string& key, BoolDataNavigator& b) override
        {
            return this->addValueRow(key, b, "Bool");
        }
        bool visit(const std::string& key, DoubleDataNavigator& d) override
        {
            return this->addValueRow(key, d, "Double");
        }
        bool visit(const std::string& key, FloatDataNavigator& f) override
        {
            return this->addValueRow(key, f, "Float");
        }
        bool visit(const std::string& key, IntDataNavigator& i) override
        {
            return this->addValueRow(key, i, "Int");
        }
        bool visit(const std::string& key, LongDataNavigator& l) override
        {
            return this->addValueRow(key, l, "Long");
        }
        bool visit(const std::string& key, StringDataNavigator& string) override
        {
            return this->addValueRow(key, string, "String");
        }

        bool visit(const std::string& key, NDArrayDataNavigator& array) override
        {
            return this->addValueRow(key, array, "ND Array");
        }

    };


}
